image: docker:latest

services:
  - docker:dind

.build-template: &build
  script:
    - docker build -t bolt-$OS -f ./contrib/Dockerfile-$OS .
    - mkdir build-$OS
    - docker run --cap-drop=dac_override -e -t -v `pwd`:/src -v `pwd`/build-$OS:/build bolt-$OS ./contrib/docker-build.sh
  artifacts:
    paths:
    - build-$OS/meson-logs
    expire_in: 1 week

fedora:
  stage: build
  variables:
    OS: fedora
  <<: *build

arch:
  stage: build
  allow_failure: true
  variables:
    OS: arch
  <<: *build

debian:
  stage: build
  variables:
    OS: debian
  <<: *build

alpine:
  stage: build
  variables:
    OS: alpine
  <<: *build

coverity:
  stage: build
  only:
    - schedules
  script:
    - mkdir build-coverity
    - docker build --build-arg ORG=gicmo --build-arg PROJECT=bolt --build-arg TOKEN=$COVERITY_TOKEN -t bolt-coverity -f ./contrib/Dockerfile-coverity .
    - docker run --rm -e COVERITY_TOKEN=$COVERITY_TOKEN -e COVERITY_EMAIL=$COVERITY_EMAIL -t -v `pwd`:/src:Z -v `pwd`/build-coverity:/build:Z bolt-coverity ./contrib/coverity.sh
  artifacts:
    paths:
    - build-coverity/cov-int/build-log.txt
    expire_in: 1 week
